diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/spectrum/model/three-gpp-channel-model.cc ns-3.42/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.41/src/spectrum/model/three-gpp-channel-model.cc	2024-02-09 14:44:08.497794400 -0800
+++ ns-3.42/src/spectrum/model/three-gpp-channel-model.cc	2024-05-29 15:29:47.172073600 -0700
@@ -291,7 +1121,8 @@
                           MakeDoubleChecker<double>())
             .AddAttribute(
                 "Scenario",
-                "The 3GPP scenario (RMa, UMa, UMi-StreetCanyon, InH-OfficeOpen, InH-OfficeMixed)",
+                "The 3GPP scenario (RMa, UMa, UMi-StreetCanyon, InH-OfficeOpen, InH-OfficeMixed, "
+                "NTN-DenseUrban, NTN-Urban, NTN-Suburban, NTN-Rural)",
                 StringValue("UMa"),
                 MakeStringAccessor(&ThreeGppChannelModel::SetScenario,
                                    &ThreeGppChannelModel::GetScenario),
@@ -377,9 +1208,12 @@
     NS_LOG_FUNCTION(this);
     NS_ASSERT_MSG(scenario == "RMa" || scenario == "UMa" || scenario == "UMi-StreetCanyon" ||
                       scenario == "InH-OfficeOpen" || scenario == "InH-OfficeMixed" ||
-                      scenario == "V2V-Urban" || scenario == "V2V-Highway",
+                      scenario == "V2V-Urban" || scenario == "V2V-Highway" ||
+                      scenario == "NTN-DenseUrban" || scenario == "NTN-Urban" ||
+                      scenario == "NTN-Suburban" || scenario == "NTN-Rural",
                   "Unknown scenario, choose between: RMa, UMa, UMi-StreetCanyon, "
-                  "InH-OfficeOpen, InH-OfficeMixed, V2V-Urban or V2V-Highway");
+                  "InH-OfficeOpen, InH-OfficeMixed, V2V-Urban, V2V-Highway, "
+                  "NTN-DenseUrban, NTN-Urban, NTN-Suburban or NTN-Rural");
     m_scenario = scenario;
 }
 
@@ -391,13 +1225,20 @@
 }
 
 Ptr<const ThreeGppChannelModel::ParamsTable>
-ThreeGppChannelModel::GetThreeGppTable(Ptr<const ChannelCondition> channelCondition,
-                                       double hBS,
-                                       double hUT,
-                                       double distance2D) const
+ThreeGppChannelModel::GetThreeGppTable(const Ptr<const MobilityModel> aMob,
+                                       const Ptr<const MobilityModel> bMob,
+                                       Ptr<const ChannelCondition> channelCondition) const
 {
     NS_LOG_FUNCTION(this);
 
+    // NOTE we assume hUT = min (height(a), height(b)) and
+    // hBS = max (height (a), height (b))
+    double hUT = std::min(aMob->GetPosition().z, bMob->GetPosition().z);
+    double hBS = std::max(aMob->GetPosition().z, bMob->GetPosition().z);
+
+    double distance2D = sqrt(pow(aMob->GetPosition().x - bMob->GetPosition().x, 2) +
+                             pow(aMob->GetPosition().y - bMob->GetPosition().y, 2));
+
     double fcGHz = m_frequency / 1.0e9;
     Ptr<ParamsTable> table3gpp = Create<ParamsTable>();
     // table3gpp includes the following parameters:
